﻿#include "IwGameActor.h"
#include "IwGameScene.h"

#include "ActorPlayer.h"


//
//
//
// ActorPlayer implementation
//
//
//

ActorPlayer::~ActorPlayer()
{
}

bool ActorPlayer::Init(CIwGameScene* scene, CIw2DImage* image, CIwGameAnimImage* anim, int width, int height)
{
	CIwGameActorImage::Init(scene, image, anim, width, height);

	FadeTimer.setDuration(1000);
	Velocity.x = IwRandMinMax(-100, 100) / 20.0f;
	Velocity.y = IwRandMinMax(-100, 100) / 20.0f;
	AngularVelocity = IwRandMinMax(-100, 100) / 20.0f;

	return true;
}

void ActorPlayer::Reset()
{
	CIwGameActor::Reset();
}

bool ActorPlayer::Update(float dt)
{
	// If fade timer has timed out then delete this actor
	if (FadeTimer.HasTimedOut())
	{
		return false;	// returning false tells the scene that we no need to be removed from the scene
	}

	// Calculate our opacity from time left on fade timer
	int opacity = FadeTimer.GetTimeLeft() / 2;
	if (opacity > 255) opacity = 255;
	Colour.a = opacity;

	return CIwGameActorImage::Update(dt);
}

bool ActorPlayer::UpdateVisual()
{
	return CIwGameActorImage::UpdateVisual();
}

void ActorPlayer::ResolveCollisions()
{
}

void ActorPlayer::NotifyCollision(CIwGameActor* other)
{
}

